#include <iostream>
#include <cmath>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    vector<string> fill;
};

Input
input_data(istream& inx)
{

bool prompt = true;
size_t number_count;
if (prompt)cerr << "Input amount of numbers: ";
inx >> number_count;

Input in;

in.numbers.resize(number_count);
if (prompt)
    {
    cerr << "Input some numbers: ";
    }

for (size_t i = 0; i < number_count; i++)
    {
    inx >> in.numbers[i];
    }

if (prompt) cerr << "Input amount of promejutkov: ";
inx >> in.bin_count;

in.fill.resize(in.bin_count);

for (size_t i = 0; i < in.bin_count; i++)
    {
        cerr << "Cvet: ";
        inx >> in.fill[i];
    }

return in;
}

Input
download(const string& address) {
    stringstream buffer;

    CURL* curl = curl_easy_init();
    if(curl)
    {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            {
            fprintf(stderr, "curl_easy_perform() failed: %s\n",
            curl_easy_strerror(res));
            exit(1);
            }


        curl_easy_cleanup(curl);
    }
    return input_data(buffer);
}

size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    size_t data_size = item_size * item_count;
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

int
main(int argc, char* argv[])
{


    Input input;

    if (argc > 1) {
        input = download(argv[1]);
    } else {
        input = input_data(cin);
    }

    curl_global_init(CURL_GLOBAL_ALL);

    auto bins = make_histogram(input.numbers, input.bin_count);

    show_histogram_svg(bins, input.fill);

    return 0;
}


